﻿using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace Frost_DK_PvP
{
    public partial class Classname : CombatRoutine
    {
        #region Methods
        #region Other
        #region Breaker Spell Mechs
        #region Collective Spell Mechs
        public bool CollectiveSpellMechs()
        {
            WoWAuraCollection Auras = StyxWoW.Me.GetAllAuras();
            foreach (WoWAura a in Auras)
            {
                if (!a.IsHarmful)
                {
                    continue;
                }
                if (a.Spell.Mechanic == WoWSpellMechanic.Asleep
                || a.Spell.Mechanic == WoWSpellMechanic.Banished
                || a.Spell.Mechanic == WoWSpellMechanic.Bleeding
                || a.Spell.Mechanic == WoWSpellMechanic.Charmed
                || a.Spell.Mechanic == WoWSpellMechanic.Dazed
                || a.Spell.Mechanic == WoWSpellMechanic.Disarmed
                || a.Spell.Mechanic == WoWSpellMechanic.Disoriented
                || a.Spell.Mechanic == WoWSpellMechanic.Distracted
                || a.Spell.Mechanic == WoWSpellMechanic.Fleeing
                || a.Spell.Mechanic == WoWSpellMechanic.Frozen
                || a.Spell.Mechanic == WoWSpellMechanic.Gripped
                || a.Spell.Mechanic == WoWSpellMechanic.Horrified
                || a.Spell.Mechanic == WoWSpellMechanic.Incapacitated
                || a.Spell.Mechanic == WoWSpellMechanic.Infected
                || a.Spell.Mechanic == WoWSpellMechanic.Polymorphed
                || a.Spell.Mechanic == WoWSpellMechanic.Rooted
                || a.Spell.Mechanic == WoWSpellMechanic.Sapped
                || a.Spell.Mechanic == WoWSpellMechanic.Shackled
                || a.Spell.Mechanic == WoWSpellMechanic.Silenced
                || a.Spell.Mechanic == WoWSpellMechanic.Slowed
                || a.Spell.Mechanic == WoWSpellMechanic.Snared)
                {
                    return true;
                }
            }
            return false;
        #endregion
        }
        #region Collective Spell Mechs
        public bool MeIsCCd()
        {
            WoWAuraCollection Auras = StyxWoW.Me.GetAllAuras();
            foreach (WoWAura a in Auras)
            {
                if (!a.IsHarmful)
                {
                    continue;
                }
                if (a.Spell.Mechanic == WoWSpellMechanic.Asleep
                || a.Spell.Mechanic == WoWSpellMechanic.Banished
                || a.Spell.Mechanic == WoWSpellMechanic.Charmed
                || a.Spell.Mechanic == WoWSpellMechanic.Dazed
                || a.Spell.Mechanic == WoWSpellMechanic.Disoriented
                || a.Spell.Mechanic == WoWSpellMechanic.Distracted
                || a.Spell.Mechanic == WoWSpellMechanic.Fleeing
                || a.Spell.Mechanic == WoWSpellMechanic.Frozen
                || a.Spell.Mechanic == WoWSpellMechanic.Gripped
                || a.Spell.Mechanic == WoWSpellMechanic.Horrified
                || a.Spell.Mechanic == WoWSpellMechanic.Incapacitated
                || a.Spell.Mechanic == WoWSpellMechanic.Polymorphed
                || a.Spell.Mechanic == WoWSpellMechanic.Rooted
                || a.Spell.Mechanic == WoWSpellMechanic.Sapped
                || a.Spell.Mechanic == WoWSpellMechanic.Shackled)
                {
                    return true;
                }
            }
            return false;
        #endregion
        }
        #endregion
        
     
        #region AddCounting
        public static bool Adds()
        {

            List<WoWUnit> mobList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                unit != null
                &&unit.IsAlive
                && unit.IsHostile
                && unit.Attackable
                && !unit.IsFriendly
               // && unit.InLineOfSight
                && unit.CanSelect
                &&unit.Guid != StyxWoW.Me.Guid
                && (unit.Location.Distance2D(Me.CurrentTarget.Location) <= 10));

            if (mobList.Count >= 5)
            {
                return true;
            }
            return false;

        }
        #endregion

        #region Slowable
        String[] Immunes = { "Hand of Freedom", "Divine Shield", "Ice Block", "Hand of Protection" };
        public bool Slowable()
        {
            foreach (string spell in Immunes)
            {
                if (StyxWoW.Me.CurrentTarget.HasAura(spell))
                {
                    return false;
                }
            }
            return true;
        }
        #endregion

        #region MeNeedHeal Defs
        public bool MeNeedHealSoon()
        {
            if (StyxWoW.Me.HealthPercent <= 75)

                return true;
            return false;
        }
        public bool MeNeedHealNow()
        {
            if (StyxWoW.Me.HealthPercent <= 50)
                return true;
            return false;
        }
        public bool MeNeedHealPriority()
        {
            if (StyxWoW.Me.HealthPercent <= 25)
                return true;
            return false;
        }
        public bool MeNeedHealUrgent()//10
        {
            if (StyxWoW.Me.HealthPercent <= 10)
                return true;
            return false;
        }
        #endregion

        #region Who We killing next
        public bool IsTargetBoss()
        {
            if (!IsTargetDummy()
            && StyxWoW.Me.CurrentTarget.MaxHealth > 500000
            && StyxWoW.Me.CurrentTarget.Level >= 90
            && StyxWoW.Me.CurrentTarget.Elite)
                return true;
            return false;
        }
        public bool IsTargetDummy()
        {
            if (StyxWoW.Me.CurrentTarget.Name == "Training Dummy"
            || StyxWoW.Me.CurrentTarget.Name == "Raider's Training Dummy")
                return true;
            return false;
        }
        public bool IsTargetNPC()
        {
            if (!StyxWoW.Me.CurrentTarget.IsPlayer
            && !StyxWoW.Me.CurrentTarget.IsFriendly
            || StyxWoW.Me.CurrentTarget.IsHostile
            || StyxWoW.Me.CurrentTarget.Attackable
            && !IsTargetBoss() && !IsTargetDummy())
                return true;
            return false;
        }
        public bool IsTargetVehicle()
        {
            if (StyxWoW.Me.CurrentTarget.Name == "Battleground Demolisher"
            || StyxWoW.Me.CurrentTarget.Name == "Catapult"
            || StyxWoW.Me.CurrentTarget.Name == "Demolisher"
            || StyxWoW.Me.CurrentTarget.Name == "Glaive Thrower"
            || StyxWoW.Me.CurrentTarget.Name == "Siege Engine")
                return true;
            return false;
        }
        public bool IsTargetCloth()
        {
            if (StyxWoW.Me.CurrentTarget.Class == WoWClass.Mage
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Priest
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Warlock)
                return true;
            return false;
        }
        public bool IsTargetLeather()
        {
            if (StyxWoW.Me.CurrentTarget.Class == WoWClass.Druid
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Rogue)
                return true;
            return false;
        }
        public bool IsTargetMail()
        {
            if (StyxWoW.Me.CurrentTarget.Class == WoWClass.Hunter
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Monk
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Shaman)
                return true;
            return false;
        }
        public bool IsTargetPlate()
        {
            if (StyxWoW.Me.CurrentTarget.Class == WoWClass.DeathKnight
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Paladin
            || StyxWoW.Me.CurrentTarget.Class == WoWClass.Warrior)
                return true;
            return false;
        }
        public bool IsMeeleDD(WoWUnit u)
        { 
            if (u.Class == WoWClass.DeathKnight
                || u.Class == WoWClass.Warrior
                || u.Class == WoWClass.Rogue
                )
                return true;
            return false;
        }
        #endregion

        #region Base || Burst
        public bool BaseRotationCheck()
        {
            if (StyxWoW.Me.CurrentTarget.Attackable
            && StyxWoW.Me.CurrentTarget.IsAlive
            && !StyxWoW.Me.HasAura("Call of Victory")
            && !StyxWoW.Me.HasAura("Pillar of Frost"))
                return true;
            return false;
        }
        public bool BurstRotationCheck()
        {
            if (StyxWoW.Me.CurrentTarget.Attackable
            &&  StyxWoW.Me.CurrentTarget.IsAlive
            && StyxWoW.Me.HasAura("Call of Victory")
            || StyxWoW.Me.HasAura("Pillar of Frost"))
                return true;
            return false;
        }
        #endregion

        #region SpellCast Methods
        private void CastSpell(string SpellName)
        {
            if (SpellManager.CanCast(SpellName))

                SpellManager.Cast(SpellName);
        }
        private void SelfCastSpell(string SpellName)
        {
            if (SpellManager.CanCast(SpellName))

                SpellManager.Cast(SpellName, StyxWoW.Me);// self cast
        }
        private void FocusCastSpell(string SpellName)
        {
            if (SpellManager.CanCast(SpellName))

                SpellManager.Cast(SpellName, StyxWoW.Me.FocusedUnit);// cast on Focus
        }
        private int MyDebuff(string SpellName, WoWUnit unit)
        {
            if (unit.HasAura(SpellName))
            {
                var auras = unit.GetAllAuras();
                foreach (var a in auras)
                {
                    if (a.Name == SpellName
                    && a.CreatorGuid == StyxWoW.Me.Guid)
                    {
                        return a.TimeLeft.Seconds;
                    }
                }
            }
            return 0;
        }
        private int MyDot(string SpellName, WoWUnit unit)
        {
            if (unit.HasAura(SpellName))
            {
                var auras = unit.GetAllAuras();
                foreach (var b in auras)
                {
                    if (b.Name == SpellName
                    && b.CreatorGuid == StyxWoW.Me.Guid)
                    {
                        return b.TimeLeft.Seconds;
                    }
                }
            }
            return 0;
        }
        #endregion
#endregion
        #region Start Auto
        private void AutoAttack()
        {
            if (!StyxWoW.Me.Combat
            &&StyxWoW.Me.GotTarget
            && Me.CurrentTarget.Distance<=30
            && SpellManager.CanCast("Icy Touch")
              )
            {
                CastSpell("Icy Touch");
            }
        }
        #endregion

        #region Buffs
        public  void PreBuff()
        {
            if (!StyxWoW.Me.Auras.ContainsKey("Horn of Winter")
                && !StyxWoW.Me.Mounted)
            {
                CastSpell("Horn of Winter");
                if (SpellManager.CanCast("Horn of Winter"))
                    Logging.Write(Colors.Blue, "HoW Buff");
                SelfCastSpell("Horn of Winter");
                
            }
            
        }

        public void Krankheiten()
        {
            if (!StyxWoW.Me.CurrentTarget.HasAura(55095))
            {
                SpellManager.Cast(49184);

            }
            else
            {

                if (!StyxWoW.Me.CurrentTarget.HasAura(55078))
                {
                    SpellManager.Cast(45462);

                }
            }


        }

        public void CC()
        {
            
        }

        #region Crowd Control
        public bool CoI()
        {
            if (!StyxWoW.Me.CurrentTarget.IsWithinMeleeRange
            &&  !StyxWoW.Me.CurrentTarget.HasAura("Chains of ice")
            && SpellManager.Spells["Obliterate"].CooldownTimeLeft.Milliseconds > 750
            && StyxWoW.Me.CurrentTarget.IsPlayer)
          {
                WoWMovement.Face();
                CastSpell("Chains of Ice");

                return true;
            }
            return false;
        }


        




        public bool DG()
        {
            if (StyxWoW.Me.CurrentTarget.Distance <= 30d
            && StyxWoW.Me.CurrentTarget.Distance >= 15d
            && StyxWoW.Me.CurrentTarget.IsPlayer)
            {
                WoWMovement.Face();
                CastSpell("Death Grip");
                if (SpellManager.CanCast("Death Grip"))
                    Logging.Write(Colors.Blue, "DG Pull/Rupt");
                return true;
            }
            return false;
        }
        #endregion

        #region MCM
        public void ResetMacro(string Which)
        {
            Lua.DoString(Which + " = 0;");
        }
        public void ResetAllMacros()
        {
            ResetMacro("MultiCastFT");
            ResetMacro("MultiCastMT");
        }
        #endregion

        
        public bool LichHealA()//'A'
        {
            if (StyxWoW.Me.HealthPercent <= 40)
            {
                CastSpell("Lichborne");
                return true;
            }
            return false;
        }
        public bool LichHealB()//'B'
        {
            if (StyxWoW.Me.HasAura("Lichborne"))
            {
                SelfCastSpell("Death Coil");
                return true;
            }
            return false;
        }
        public bool LCCB()
        {
           
            return false;
        }
       
        #endregion
        #region AOE
        public bool UnholyBlight(){
            if(SpellManager.CanCast("Unholy Blight")){
             CastSpell("Unholy Blight");
               return true;}
            return false;
        } 
        
                  
        #endregion
        #region single
        #endregion

        public bool slowed()
        {

            WoWAuraCollection Auras = StyxWoW.Me.CurrentTarget.GetAllAuras();
            foreach (WoWAura a in Auras)
            {
              
                 if (a.Spell.Mechanic == WoWSpellMechanic.Slowed
                  || a.Spell.Mechanic == WoWSpellMechanic.Snared
                  || a.Spell.Mechanic == WoWSpellMechanic.Stunned
                  || a.Spell.Mechanic == WoWSpellMechanic.Rooted
                  || a.Spell.Mechanic == WoWSpellMechanic.Polymorphed
                  || a.Spell.Mechanic == WoWSpellMechanic.Frozen
                  || a.Spell.Mechanic == WoWSpellMechanic.Charmed
                  || a.Spell.Mechanic == WoWSpellMechanic.Banished
                  || a.Spell.Mechanic == WoWSpellMechanic.Asleep) return true;

            }
            return false;
        }
        #endregion
        public bool targetCC(WoWUnit u)
        {
            WoWAuraCollection Auras = u.GetAllAuras();
            foreach (WoWAura a in Auras)
            {
                if (!a.IsHarmful)
                {
                    continue;
                }
                if (a.Spell.Mechanic == WoWSpellMechanic.Asleep
                || a.Spell.Mechanic == WoWSpellMechanic.Banished
                || a.Spell.Mechanic == WoWSpellMechanic.Charmed
                || a.Spell.Mechanic == WoWSpellMechanic.Dazed
                || a.Spell.Mechanic == WoWSpellMechanic.Disoriented
                || a.Spell.Mechanic == WoWSpellMechanic.Distracted
                || a.Spell.Mechanic == WoWSpellMechanic.Fleeing
                || a.Spell.Mechanic == WoWSpellMechanic.Frozen
                || a.Spell.Mechanic == WoWSpellMechanic.Gripped
                || a.Spell.Mechanic == WoWSpellMechanic.Horrified
                || a.Spell.Mechanic == WoWSpellMechanic.Incapacitated
                || a.Spell.Mechanic == WoWSpellMechanic.Polymorphed
                || a.Spell.Mechanic == WoWSpellMechanic.Rooted
                || a.Spell.Mechanic == WoWSpellMechanic.Sapped
                || a.Spell.Mechanic == WoWSpellMechanic.Shackled)
                {
                    return true;
                }
            }
            return false;

        }

        public bool CCdAdd()
        {

            List<WoWUnit> mobList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                unit.Guid != Me.Guid
                && unit.IsAlive
                && unit.IsHostile
                && !targetCC(unit)
                && unit.Attackable
                && !unit.IsFriendly
                && (unit.Location.Distance(Me.CurrentTarget.Location) <= 10 || unit.Location.Distance2D(Me.CurrentTarget.Location) <= 10));

            if (mobList.Count >= 1)
            {
                return true;                
            }
            return false;

        }
        public bool NeedDispell() {
            WoWAuraCollection Auras =StyxWoW.Me.CurrentTarget.GetAllAuras();
            foreach (WoWAura a in Auras)
            {

                if (a.SpellId == 1022
                  ||a.SpellId == 108978
                  ||a.SpellId == 1044
                  ||a.SpellId == 54428
                  || a.SpellId == 29166)
                {
               
                    return true;    
                }
            }
            return false;
        }
        public bool NeedDispell(WoWPlayer p)
        {
            WoWAuraCollection Auras = p.GetAllAuras();
            foreach (WoWAura a in Auras)
            {

                if ( a.SpellId == 54428  // Göttliche Bitte
                  || a.SpellId == 108978 // Zeitverschiebung
                  || a.SpellId == 1022   // Hand des Schutzes
                  || a.SpellId == 29166  // Anregen
                  || a.SpellId == 31884  // Zornige Vergeltung
                  || a.SpellId == 33206) // Schmerz Unterdrückung
                {
                    Logging.Write(Colors.Blue, "need despell"+p.ToString());
                    return true;
                }
            }
            
            return false;
        }
        public bool NeedSpellsteel(WoWPlayer p)
        {
            int sID =p.CastingSpellId;

            if (sID == 33786
             || sID == 118
             || sID == 5782
             || sID == 51514) 
                {
                    Logging.Write(Colors.Blue, "spell steal" + p.ToString());
                    return true;
                }
            

            return false;
        }

        public bool IsCapturing(WoWPlayer p)
        {
            int sID = p.CastingSpellId;

            if (sID == 98322
             || sID == 98323
             || sID == 98324)
            {
                Logging.Write(Colors.Blue, "anti Tap!!! " + p.ToString());
                return true;
            }


            return false;
        }
        public WoWPlayer DispellHim()
        {   List<WoWPlayer> mobList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(player =>
                player.Guid != Me.Guid
                && player.IsAlive
                //&& player.InLineOfSight
                && player.Location.Distance2D(Me.Location) < 30
                && NeedDispell(player)
                && player.Attackable);

            if (mobList.Count() == 0) return nullPlayer; return mobList[0];     
            
         }

        public WoWUnit StealSpell()
        {
            List<WoWPlayer> mobList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(player =>
                player.Guid != Me.Guid
                && player.IsAlive
               // && player.InLineOfSight
                && player.Location.Distance2D(Me.Location) < 30
                && NeedSpellsteel(player)
                && player.Attackable);

            if (mobList.Count() == 0) return nullPlayer; return mobList[0];

        }
        public WoWUnit NeedInterrupt()
        {
            List<WoWPlayer> mobList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(player =>
                player.Guid != Me.Guid
                && player.IsAlive
                //&& player.InLineOfSight
                && player.Location.Distance2D(Me.Location) < 30
                && player.Attackable
                && player.IsCastingHealingSpell
                || NeedSpellsteel(player));

            
            if (mobList.Count() == 0) return nullPlayer; return mobList[0];

        }
        public WoWUnit IsCapturingNeedInterrupt()
        {
            List<WoWPlayer> mobList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(player =>
                player.Guid != Me.Guid
                && player.IsAlive
               // && player.InLineOfSight
                && player.Location.Distance2D(Me.Location) < 30
                && player.Attackable
                && IsCapturing(player));


            if (mobList.Count() == 0) return nullPlayer; return mobList[0];

        }

        public WoWUnit GorefiendsGrasp()
                    {
                        List<WoWPlayer> mobList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(player =>
                player.Guid != Me.Guid
                && player.IsAlive
                && player.Location.Distance2D(Me.CurrentTarget.Location) < 30
               // && player.InLineOfSight
                && NeedMassGrap(player)
                && player.Attackable);

                        if (mobList.Count() == 0) return nullUnit; return mobList[0];     
                    }

         public bool NeedMassGrap(WoWPlayer p)
         {
             WoWAuraCollection Auras = p.GetAllAuras();
             foreach (WoWAura a in Auras)
             {
                 if (a.SpellId == 113724
                   || a.SpellId == 78675)
                 {

                     return true;
                 }
             }
             return false;
         }
         public bool Spreadhelper(WoWUnit p)
         {
             WoWAuraCollection Auras = p.GetAllAuras();
             foreach (WoWAura a in Auras)
             {
                 if (!(a.SpellId == 59879)
                   || !(a.SpellId == 55095))
                 {

                     return true;
                 }
             }
             return false;
         }

         public bool needtospread() {
             if (StyxWoW.Me.CurrentTarget.HasAura(55095)
                 && StyxWoW.Me.CurrentTarget.HasAura(59879)) {

                     List<WoWUnit> mobList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                    unit.Guid != Me.Guid
                    && unit.IsAlive
                    && unit.IsHostile
                    && Spreadhelper(unit)
                    && unit.Attackable
                    && !unit.IsFriendly
                    && (unit.Location.Distance(Me.CurrentTarget.Location) <= 10 || unit.Location.Distance2D(Me.CurrentTarget.Location) <= 10));

                     List<WoWPlayer> playerList = ObjectManager.GetObjectsOfType<WoWPlayer>(false).FindAll(unit =>
                    unit.Guid != Me.Guid
                    && unit.IsAlive
                    && unit.IsHostile
                    && Spreadhelper(unit)
                    && unit.Attackable
                    && !unit.IsFriendly
                    && (unit.Location.Distance(Me.CurrentTarget.Location) <= 10 || unit.Location.Distance2D(Me.CurrentTarget.Location) <= 10));
                 
                 
                 if ((mobList.Count + playerList.Count) >= 1)
                     {
                         return true;
                     }
                     return false;

             }

             return false;
             
             
         }


        public void HowlingBlast() {
            if (CCdAdd() || NeedDispell()) {
                if (SpellManager.CanCast("Icy Touch")) CastSpell("Icy Touch");
            }
            if(!CCdAdd()){
                if(SpellManager.CanCast("Howling Blast")) CastSpell("Howling Blast");
            }
        }
        public TimeSpan SpellCD(String s) {
            SpellFindResults sfr;
            if (SpellManager.FindSpell(s, out sfr))
                return (sfr.Override ?? sfr.Original).CooldownTimeLeft;
            return TimeSpan.FromSeconds(20);
        }

        public bool Plagueleech() {
            if (StyxWoW.Me.CurrentTarget.GetAuraByName("Frost Fever") != null
             && StyxWoW.Me.CurrentTarget.GetAuraByName("Blood Plague") != null)
            {
                TimeSpan a1 = StyxWoW.Me.CurrentTarget.GetAuraByName("Frost Fever").TimeLeft;
                TimeSpan a2 = StyxWoW.Me.CurrentTarget.GetAuraByName("Blood Plague").TimeLeft;

                if (a1 <= TimeSpan.FromSeconds(3) || a2 <= TimeSpan.FromSeconds(3))
                    return true;
            }
                return false;
        }


        public bool AddsTargetME(int i)
        {

            List<WoWUnit> mobList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                unit.Guid != Me.Guid
                && unit.IsAlive
                && unit.IsHostile
                && unit.Attackable
                && !unit.IsFriendly
                && unit.GotTarget
                && unit.CurrentTargetGuid == Me.Guid
                && unit.Location.Distance(Me.CurrentTarget.Location) <= 8);

            if (mobList.Count >= i)
            {
                return true;
            }
            return false;

        }




    }
}